unit Komunikace;

interface
    procedure PosliStream(ip:string;port,local_port:integer;data:string);
    procedure PosliSymetrickyKlic(key:string;PK:string;URL:string;Port:integer;id:integer);
    procedure PosliVerejnyKlic(URL:string;Port:integer;PK:string;id:integer);
    procedure PrijmiVerejnyKlic(data:string;var PK:string);
    procedure PrijmiSymetrickyKlic(data:string;PK,PRK:string;var key:string);
    procedure PosliZpravu(URL:string;Port:integer;zprava:string;id:integer;PK:string;SK:string);
    procedure PrijmiZpravu(data,SK,PK,PRK:string;var zprava:string);
    function GenerujSymetrickyKlic(delka:integer):string;
    function VytvorZpravu(zprava,SK,PK:string):string;
    function DekodujZpravu(data,SK,PK,PRK:string):string;
    procedure PosliDvojitouZpravu(zprava1,zprava2,URL:string;id,Port:integer);
    procedure PrijmiDvojitouZpravu(data,PK,PRK,SK:string;var zprava1,zprava2:string);
    function LocalIP : string;

const
    Port_Zak = 2000;
    Port_Obch = 2004;
    Port_Banka_Zak=2001;
    Port_Banka_Obch=2002;
    Port_PG = 2003;

implementation

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RSA, NMUDP, Sample, DECUtil, HCMngr, Cipher, Cipher1, Winsock;


procedure PosliSymetrickyKlic(key:string;PK:string;URL:string;Port:integer;id:integer);
var key_enc,key_enc_hex,body:string;
    i:integer;
    RSAX:TRSA;
begin
     RSAX:=TRSA.Create(nil);
     try
        RSAX.KeyBits:=kb0512;
        RSAX.PublicKey:=PK;
        RSAX.EncryptString(key,key_enc);
        key_enc_hex:=StrToFormat(PChar(key_enc),length(key_enc),fmtHEX);

        body:=inttohex(id,2)+inttohex(length(key_enc_hex),4)+key_enc_hex;
        PosliStream(URL,Port,Port,body);
     finally
        RSAX.Free;
     end;
end;

procedure PosliVerejnyKlic(URL:string;Port:integer;PK:string;id:integer);
var key_hex,body:string;
begin
     key_hex:=StrToFormat(PChar(PK),length(PK),fmtHEX);
     body:=inttohex(id,2)+inttohex(length(key_hex),4)+key_hex;

     PosliStream(URL,Port,Port,body);
end;

procedure PrijmiVerejnyKlic(data:string;var PK:string);
var i:integer;
    delka:integer;
begin
     delka:=strtoint('$'+copy(data,3,4));
     PK:=FormatToStr(PChar(Copy(data,3+4,delka)),delka,fmtHEX);
end;


procedure PosliStream(ip:string;port,local_port:integer;data:string);
var MyStream: TMemoryStream;
    udp:TNMUDP;
begin
     sleep(1000);
     udp:=TNMUDP.Create(nil);
     try
        udp.RemoteHost:=ip;
        udp.LocalPort:=2000;
        if port>0 then
           udp.RemotePort:=port;
        MyStream := TMemoryStream.Create;
        try
           MyStream.Write(data[1], Length(data));
           udp.SendStream(MyStream);
        finally
           MyStream.Free;
        end;
     finally
        udp.Free;
     end;
end;

procedure PrijmiSymetrickyKlic(data:string;PK,PRK:string;var key:string);
var enc_key,enc_key_hex:string;
    delka:integer;
    RSAX:TRSA;
begin
     key:='';
     delka:=strtoint('$'+copy(data,3,4));
     enc_key_hex:=copy(data,3+4,delka);
     enc_key:=FormatToStr(PChar(enc_key_hex),length(enc_key_hex),fmtHEX);

     RSAX:=TRSA.Create(nil);
     try
        RSAX.KeyBits:=kb0512;
        RSAX.PublicKey:=PK;
        RSAX.PrivateKey:=PRK;
        RSAX.DecryptString(enc_key,key);
     finally
        RSAX.Free;
     end;
end;

procedure PosliZpravu(URL:string;Port:integer;zprava:string;id:integer;PK:string;SK:string);
var HashMan:THashManager;
    Cipher:TCipherManager;
    RSAX:TRSA;
    obalka,enc_obalka,obalka_hex:string;
    enc_digest:string;
begin
     obalka:=inttohex(length(zprava),4)+zprava;
     HashMan:=THashManager.Create(nil);
     try
        HashMan.Algorithm:='Message Digest 5';
        HashMan.CalcString(zprava);
        RSAX:=TRSA.Create(nil);
        try
           RSAX.KeyBits:=kb0512;
           RSAX.PublicKey:=PK;
           RSAX.EncryptString(HashMan.Digest,enc_digest);
           obalka_hex:=StrToFormat(PChar(enc_digest),length(enc_digest),fmtHEX);
           obalka:=obalka+inttohex(length(obalka_hex),4)+obalka_hex;
           Cipher:=TCipherManager.Create(nil);
           try
              Cipher.HashManager:=HashMan;
              Cipher.Algorithm:='DES Triple 24byte';
              Cipher.InitKey(SK,nil);
              enc_obalka:=Cipher.EncodeString(obalka);
              obalka_hex:=StrToFormat(PChar(enc_obalka),length(enc_obalka),fmtHEX);
              obalka:=inttohex(id,2)+inttohex(length(obalka_hex),4)+obalka_hex;
              PosliStream(URL,Port,Port,obalka);
           finally
              Cipher.Free;
           end;
        finally
           RSAX.Free;
        end;
     finally
        HashMan.Free;
     end;
end;

procedure PrijmiZpravu(data,SK,PK,PRK:string;var zprava:string);
var HashMan:THashManager;
    Cipher:TCipherManager;
    RSAX:TRSA;
    obalka,obalka_enc,obalka_hex:string;
    enc_digest,digest_in,digest_out:string;
    delka,d_digest,d_zprava:integer;
begin
     HashMan:=THashManager.Create(nil);
     try
        HashMan.Algorithm:='Message Digest 5';
        Cipher:=TCipherManager.Create(nil);
        try
           Cipher.HashManager:=HashMan;
           Cipher.Algorithm:='DES Triple 24byte';
           Cipher.InitKey(SK,nil);
           delka:=strtoint('$'+copy(data,3,4));
           obalka_hex:=copy(data,3+4,delka);
           obalka_enc:=FormatToStr(PChar(obalka_hex),length(obalka_hex),fmtHEX);
           obalka:=Cipher.DecodeString(obalka_enc);
           d_zprava:=strtoint('$'+copy(obalka,1,4));
           zprava:=copy(obalka,5,d_zprava);
           d_digest:=strtoint('$'+copy(obalka,5+d_zprava,4));
           obalka_hex:=copy(obalka,5+d_zprava+4,d_digest);
           enc_digest:=FormatToStr(PChar(obalka_hex),length(obalka_hex),fmtHEX);
           RSAX:=TRSA.Create(nil);
           try
              RSAX.KeyBits:=kb0512;
              RSAX.PublicKey:=PK;
              RSAX.PrivateKey:=PRK;
              RSAX.DecryptString(enc_digest,digest_in);
              HashMan.CalcString(zprava);
              digest_out:=HashMan.Digest;
              if digest_in<>digest_out then
                 zprava:='*** Chyba: Message digest vypoten a message digest ze zprvy nen shodn !!!';
           finally
              RSAX.Free;
           end;
        finally
           Cipher.Free;
        end;
     finally
        HashMan.Free;
     end;

end;

function GenerujSymetrickyKlic(delka:integer):string;
var i:integer;
begin
     Result:='';
     Randomize;
     for i:=1 to delka do
         Result:=Result+string(chr(byte(random($ff))));
end;

function VytvorZpravu(zprava,SK,PK:string):string;
var HashMan:THashManager;
    Cipher:TCipherManager;
    RSAX:TRSA;
    obalka,enc_obalka,obalka_hex:string;
    enc_digest:string;
begin
     obalka:=inttohex(length(zprava),4)+zprava;
     HashMan:=THashManager.Create(nil);
     try
        HashMan.Algorithm:='Message Digest 5';
        HashMan.CalcString(zprava);
        RSAX:=TRSA.Create(nil);
        try
           RSAX.KeyBits:=kb0512;
           RSAX.PublicKey:=PK;
           RSAX.EncryptString(HashMan.Digest,enc_digest);
           obalka_hex:=StrToFormat(PChar(enc_digest),length(enc_digest),fmtHEX);
           obalka:=obalka+inttohex(length(obalka_hex),4)+obalka_hex;
           Cipher:=TCipherManager.Create(nil);
           try
              Cipher.HashManager:=HashMan;
              Cipher.Algorithm:='DES Triple 24byte';
              Cipher.InitKey(SK,nil);
              enc_obalka:=Cipher.EncodeString(obalka);
              obalka_hex:=StrToFormat(PChar(enc_obalka),length(enc_obalka),fmtHEX);
              obalka:=inttohex(length(obalka_hex),4)+obalka_hex;
              Result:=obalka;
           finally
              Cipher.Free;
           end;
        finally
           RSAX.Free;
        end;
     finally
        HashMan.Free;
     end;
end;

procedure PosliDvojitouZpravu(zprava1,zprava2,URL:string;id,Port:integer);
var zprava:string;
begin
     zprava:=inttohex(id,2)+zprava1+zprava2;
     PosliStream(URL,Port,Port,zprava);
end;

procedure PrijmiDvojitouZpravu(data,PK,PRK,SK:string;var zprava1,zprava2:string);
var HashMan:THashManager;
    Cipher:TCipherManager;
    RSAX:TRSA;
    obalka,obalka_enc,obalka_hex,data_bak:string;
    enc_digest,digest_in,digest_out:string;
    delka,d_digest,d_zprava:integer;
begin
     delka:=strtoint('$'+copy(data,3,4));
     zprava1:=copy(data,3,delka+4);
     d_zprava:=strtoint('$'+copy(data,3+4+delka,4));
     data_bak:=data;
     data:=copy(data,3+4+delka,d_zprava+4);

     HashMan:=THashManager.Create(nil);
     try
        HashMan.Algorithm:='Message Digest 5';
        Cipher:=TCipherManager.Create(nil);
        try
           Cipher.HashManager:=HashMan;
           Cipher.Algorithm:='DES Triple 24byte';
           Cipher.InitKey(SK,nil);
           delka:=strtoint('$'+copy(data,1,4));
           obalka_hex:=copy(data,1+4,delka);
           obalka_enc:=FormatToStr(PChar(obalka_hex),length(obalka_hex),fmtHEX);
           obalka:=Cipher.DecodeString(obalka_enc);
           d_zprava:=strtoint('$'+copy(obalka,1,4));
           zprava2:=copy(obalka,5,d_zprava);
           d_digest:=strtoint('$'+copy(obalka,5+d_zprava,4));
           obalka_hex:=copy(obalka,5+d_zprava+4,d_digest);
           enc_digest:=FormatToStr(PChar(obalka_hex),length(obalka_hex),fmtHEX);
           RSAX:=TRSA.Create(nil);
           try
              RSAX.KeyBits:=kb0512;
              RSAX.PublicKey:=PK;
              RSAX.PrivateKey:=PRK;
              RSAX.DecryptString(enc_digest,digest_in);
              HashMan.CalcString(zprava2);
              digest_out:=HashMan.Digest;
              if digest_in<>digest_out then
                 zprava2:='*** Chyba: Message digest vypoten a message digest ze zprvy nen shodn !!!';
           finally
              RSAX.Free;
           end;
        finally
           Cipher.Free;
        end;
     finally
        HashMan.Free;
     end;
end;

function DekodujZpravu(data,SK,PK,PRK:string):string;
var zprava:string;
begin
     PrijmiZpravu('xx'+data,SK,PK,PRK,zprava);
     Result:=zprava;
end;

function LocalIP : string;
type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
var
    phe  : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I    : Integer;
    GInitData      : TWSADATA;
begin
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe :=GetHostByName(buffer);
    if phe = nil then Exit;
    pptr := PaPInAddr(Phe^.h_addr_list);
    I := 0;
    while pptr^[I] <> nil do begin
      result:=StrPas(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
    WSACleanup;
end;


end.
