unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, NMUDP, Sample, DECUtil, Komunikace, Cipher, Cipher1, HCMngr,
  RSA, Menus;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    NMUDP1: TNMUDP;
    HashManager1: THashManager;
    CipherManager1: TCipherManager;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    ClearMeno1: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    procedure NMUDP1DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String);
    procedure FormCreate(Sender: TObject);
    procedure ClearMeno1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
  private
    { Private declarations }
    Cena_Celkem:integer;
    PK_Zak,PK_Obch,PK_PG,PK_Banka_Zak,PK_Banka_Obch:string;
    PRK_Obch,SymetricKey,SymetricKey2,SymetricKey3,Zprava_PG,URL_Banka_Obch,URL_PG,URL_Zak:string;
    procedure MemoHlavicka(memo:TMemo);
    procedure PrijmiZadost(str:string;URL:string);
    function ZakoupeneZbozi(id:integer;data:string;var nazev:string;var pocet,cena:integer):integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.NMUDP1DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String);
var
  MyStream: TMemoryStream;
  TmpStr: String;
begin
  MyStream := TMemoryStream.Create;
  try
    NMUDP1.ReadStream(MyStream);
    SetLength(TmpStr,NumberBytes);
    MyStream.Read(TmpStr[1],NumberBytes);
    MemoHlavicka(Memo1);
    Form1.Memo1.Lines.Add('Pijata data od '+FromIP+', Dlka: '+IntToStr(NumberBytes)+' bajt');
    PrijmiZadost(TmpStr,FromIP);
  finally
    MyStream.Free;
  end;
end;

procedure TForm1.PrijmiZadost(str:string;URL:string);
var id,i,pocet,cena,celkem,postovne,balne:integer;
    nazev,zprava:string;
begin
     id:=strtoint('$'+Copy(str,1,2));
     Form1.Memo1.Lines.Add('   ID zprvy: '+inttostr(id));
     case id of
         99: begin
                  PrijmiVerejnyKlic(str,PK_Zak);
                  Form1.Memo1.Lines.Add('   Veejn kl zkaznka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Zak),length(PK_Zak),fmtHEX));
                  URL_Zak:=URL;
                  PosliVerejnyKlic(URL,Port_Zak,PK_Obch,96);
             end;
         89: begin
                  PrijmiSymetrickyKlic(str,PK_Obch,PRK_Obch,SymetricKey);
                  Form1.Memo1.Lines.Add('   Symetrick kl zkaznka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(SymetricKey),length(SymetricKey),fmtHEX));
             end;
         79: begin
                  PrijmiDvojitouZpravu(str,PK_Obch,PRK_Obch,SymetricKey,Zprava_PG,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,22,PK_Zak,SymetricKey);
                  end else begin
                      Form1.Memo1.Lines.Add('   Objednvka zkaznka:');
                      celkem:=0;
                      Form1.Memo1.Lines.Add(Format('   %-30s %5s %10s',['Nzev','Poet','Cena']));
                      for i:=1 to ZakoupeneZbozi(0,zprava,nazev,pocet,cena) do begin
                          ZakoupeneZbozi(i,zprava,nazev,pocet,cena);
                          celkem:=celkem+cena;
                          Form1.Memo1.Lines.Add(Format('   %-30s %4d %10d K',[nazev,pocet,cena]));
                      end;
                      postovne:=strtoint(Form1.Edit2.Text);
                      balne:=strtoint(Form1.Edit3.Text);
                      Form1.Memo1.Lines.Add('');
                      Form1.Memo1.Lines.Add(Format('   Cena za zbo: %9d K',[celkem]));
                      Form1.Memo1.Lines.Add(Format('   Potovn     : %9d K',[postovne]));
                      Form1.Memo1.Lines.Add(Format('   Baln        : %9d K',[balne]));
                      Form1.Memo1.Lines.Add('   ---------------------------');
                      Cena_Celkem:=balne+postovne+celkem;
                      Form1.Memo1.Lines.Add(Format('   Cena celkem  : %9d K',[Cena_Celkem]));
                      URL_Banka_Obch:=Form1.Edit1.Text;
                      PosliVerejnyKlic(URL_Banka_Obch,Port_Banka_Obch,PK_Obch,96);
                  end;
             end;
         97: begin
                  PrijmiVerejnyKlic(str,PK_Banka_Obch);
                  Form1.Memo1.Lines.Add('   Veejn kl banky obchodnka:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Banka_Obch),length(PK_Banka_Obch),fmtHEX));
                  SymetricKey3:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey3,PK_Banka_Obch,URL_Banka_Obch,Port_Banka_Obch,88);
                  PosliZpravu(URL_Banka_Obch,Port_Banka_Obch,'IP',75,PK_Banka_Obch,SymetricKey3);
             end;
         76: begin
                  PrijmiZpravu(str,SymetricKey3,PK_Obch,PRK_Obch,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,22,PK_Zak,SymetricKey);
                  end else begin
                     Form1.Memo1.Lines.Add('   Odpov na dost o URL platebn brny.');
                     Form1.Memo1.Lines.Add('   URL: '+zprava);
                     URL_PG:=zprava;
                     PosliVerejnyKlic(URL_PG,Port_PG,PK_Obch,96);
                  end;
             end;
         95: begin
                  PrijmiVerejnyKlic(str,PK_PG);
                  Form1.Memo1.Lines.Add('   Veejn kl platebn brny:');
                  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_PG),length(PK_PG),fmtHEX));
                  SymetricKey2:=GenerujSymetrickyKlic(24);
                  PosliSymetrickyKlic(SymetricKey2,PK_PG,URL_PG,Port_PG,88);
                  Form1.HashManager1.Algorithm:='Secure Hash Algorithm';
                  Form1.HashManager1.CalcString(Form1.Edit4.Text+' '+Form1.Edit5.Text+' '+
                                                Form1.Edit6.Text);
                  zprava:=Form1.HashManager1.DigestString[fmtHEX];
                  PosliDvojitouZpravu(Zprava_PG,VytvorZpravu(zprava,SymetricKey2,PK_PG),URL_PG,79,Port_PG);
                  PosliZpravu(URL_PG,Port_PG,inttostr(Cena_Celkem),3,PK_PG,SymetricKey2);
             end;
          9: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Obch,PRK_Obch,zprava);
                  if copy(zprava,1,3)='***' then begin
                     Form1.Memo1.Lines.Add(zprava);
                     Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
                     PosliZpravu(URL_Zak,Port_Zak,zprava,22,PK_Zak,SymetricKey);
                  end else begin
                     Form1.Memo1.Lines.Add('   Na et obchodnka byla pipsna stka '+zprava+' K');
                  end;
             end;
         20: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Obch,PRK_Obch,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         21: begin
                  PrijmiZpravu(str,SymetricKey,PK_Obch,PRK_Obch,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
         25: begin
                  PrijmiZpravu(str,SymetricKey2,PK_Obch,PRK_Obch,zprava);
                  Form1.Memo1.Lines.Add(zprava);
                  Form1.Memo1.Lines.Add('--- KONEC SPOJEN ---');
             end;
     end;
end;

procedure TForm1.MemoHlavicka(memo:TMemo);
begin
     memo.Lines.Add('');
     memo.Lines.Add(FormatDateTime('dd.mm.yyyy ',Date)+FormatDateTime('hh:nn:ss',Time));
end;

procedure TForm1.FormCreate(Sender: TObject);
var time_start,time_end:TDateTime;
begin
  MemoHlavicka(Form1.Memo1);
  Form1.Memo1.Lines.Add('Generuji veejn a privtn kl ...');
  time_start:=Time;
  PK_Obch:='++11Ik:4ystSFmOAD-VLnWMSmNrU3UVwDSTSYxO6v5ke'+
                        'VZD+uiildDPhN56LBlh6mq3zrBLJqPyO9xMa3O3OvFYap+Vh+';
  PRK_Obch:='4ystSFmOAD-VLnWMSmNrU3UVwDSTSYxO6v5keVZD+uiildDP'+
                         'hN56LBlh6mq3zrBLJqPyO9xMa3O3OvFYap+Vh+:tIraMqfvX'+
                         'vhFGJliQYkoyFce+40RWyo7ql7NKH8jHqDhQB9rT0aLAioatf-2816E66NwCoUC0ggsOTXlPn1oiU';

  time_end:=Time;
  Form1.Memo1.Lines.Add('   Privtn kl:');
  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PRK_Obch),length(PRK_Obch),fmtHEX));
  Form1.Memo1.Lines.Add('   Veejn kl:');
  Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Obch),length(PK_Obch),fmtHEX));
  Form1.Memo1.Lines.Add('   Hotovo , doba generovn: '+TimeToStr(time_end-time_start));
end;

procedure TForm1.ClearMeno1Click(Sender: TObject);
begin
     Form1.Memo1.Clear;
     Form1.Memo1.Lines.Add('   Privtn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PRK_Obch),length(PRK_Obch),fmtHEX));
     Form1.Memo1.Lines.Add('   Veejn kl:');
     Form1.Memo1.Lines.Add('   '+StrToFormat(PChar(PK_Obch),length(PK_Obch),fmtHEX));
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
     Form1.Close;
end;

function TForm1.ZakoupeneZbozi(id:integer;data:string;var nazev:string;var pocet,cena:integer):integer;
var Tmp:TStringList;
    tmp_str:string;
begin
        Tmp:=TStringList.Create;
        try
           if (data[1]=#13) and (data[2]=#10) then
              data:=copy(data,3,length(data));
           Tmp.Text:=data;
           Result:=Tmp.Count;
           if id>0 then begin
              nazev:=Copy(Tmp.Strings[id-1],1,pos(';',Tmp.Strings[id-1])-1);
              tmp_str:=Copy(Tmp.Strings[id-1],pos(';',Tmp.Strings[id-1])+1,length(Tmp.Strings[id-1]));
              pocet:=strtoint(Copy(tmp_str,1,pos(';',tmp_str)-1));
              cena:=strtoint(Copy(tmp_str,pos(';',tmp_str)+1,length(tmp_str)));
           end else begin
              nazev:='';
              pocet:=0;
              cena:=0;
           end;
        finally
           Tmp.Free;
        end;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
     if copy(Form1.Memo1.Lines[Form1.Memo1.Lines.Count],1,3)='---' then begin
        Zprava_PG:='';
        SymetricKey:='';
        SymetricKey2:='';
        SymetricKey3:='';
        PK_Zak:='';
        PK_PG:='';
        PK_Banka_Zak:='';
        PK_Banka_Obch:='';
     end;
end;

end.
